"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var AbstractService = require('../AbstractService');
var LayersService = /*#__PURE__*/function (_AbstractService) {
  (0, _inherits2["default"])(LayersService, _AbstractService);
  var _super = _createSuper(LayersService);
  function LayersService() {
    (0, _classCallCheck2["default"])(this, LayersService);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(LayersService, [{
    key: "descriptionWithVersionKey",
    value: function descriptionWithVersionKey(versionKey) {
      return 'created by serverless-layers plugin (' + versionKey + ')';
    }
  }, {
    key: "publishVersion",
    value: function () {
      var _publishVersion = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(versionKey) {
        var _this = this;
        var params;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              params = {
                Content: {
                  S3Bucket: this.bucketName,
                  S3Key: this.zipFileKeyName
                },
                LayerName: this.layerName,
                Description: this.descriptionWithVersionKey(versionKey),
                CompatibleRuntimes: this.plugin.settings.compatibleRuntimes,
                CompatibleArchitectures: this.plugin.settings.compatibleArchitectures
              };
              return _context.abrupt("return", this.awsRequest('Lambda:publishLayerVersion', params, {
                checkError: true
              }).then(function (result) {
                _this.plugin.log('New layer version published...');
                _this.plugin.cacheObject.LayerVersionArn = result.LayerVersionArn;
                return result;
              }));
            case 2:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function publishVersion(_x) {
        return _publishVersion.apply(this, arguments);
      }
      return publishVersion;
    }()
  }, {
    key: "findVersionChecksumInList",
    value: function () {
      var _findVersionChecksumInList = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(versionKey, marker) {
        var params, result, description, matchingLayerVersion;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              params = {
                LayerName: this.layerName
                // TODO: Question: is layer name specific enough?  Is there a way to deploy multiple runtime architectures per name?
                // CompatibleRuntime: this.plugin.settings.compatibleRuntimes,
                // CompatibleArchitecture: this.plugin.settings.compatibleArchitectures
              };

              if (marker) {
                params.Marker = marker;
              }
              _context2.next = 4;
              return this.awsRequest('Lambda:listLayerVersions', params, {
                checkError: true
              });
            case 4:
              result = _context2.sent;
              description = this.descriptionWithVersionKey(versionKey);
              matchingLayerVersion = result.LayerVersions.find(function (layer) {
                return layer.Description === description;
              });
              if (!matchingLayerVersion) {
                _context2.next = 11;
                break;
              }
              return _context2.abrupt("return", matchingLayerVersion.LayerVersionArn);
            case 11:
              if (!result.NextMarker) {
                _context2.next = 15;
                break;
              }
              return _context2.abrupt("return", this.findVersionChecksumInList(versionKey, result.NextMarker));
            case 15:
              return _context2.abrupt("return", null);
            case 16:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function findVersionChecksumInList(_x2, _x3) {
        return _findVersionChecksumInList.apply(this, arguments);
      }
      return findVersionChecksumInList;
    }()
  }, {
    key: "checkLayersForVersionKey",
    value: function () {
      var _checkLayersForVersionKey = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(versionKey) {
        var layerVersionArn;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              this.plugin.log('Looking for version with "' + versionKey + '"');
              _context3.next = 3;
              return this.findVersionChecksumInList(versionKey);
            case 3:
              layerVersionArn = _context3.sent;
              if (!layerVersionArn) {
                _context3.next = 6;
                break;
              }
              return _context3.abrupt("return", layerVersionArn);
            case 6:
            case "end":
              return _context3.stop();
          }
        }, _callee3, this);
      }));
      function checkLayersForVersionKey(_x4) {
        return _checkLayersForVersionKey.apply(this, arguments);
      }
      return checkLayersForVersionKey;
    }()
  }, {
    key: "cleanUpLayers",
    value: function () {
      var _cleanUpLayers = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        var _this2 = this;
        var retainVersions,
          params,
          response,
          deletionCandidates,
          deleteQueue,
          _args4 = arguments;
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) switch (_context4.prev = _context4.next) {
            case 0:
              retainVersions = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : 0;
              params = {
                LayerName: this.layerName
              };
              _context4.next = 4;
              return this.awsRequest('Lambda:listLayerVersions', params, {
                checkError: true
              });
            case 4:
              response = _context4.sent;
              if (!(response.LayerVersions.length <= retainVersions)) {
                _context4.next = 8;
                break;
              }
              this.plugin.log('Layers removal finished.\n');
              return _context4.abrupt("return");
            case 8:
              if (!this.plugin.settings.retainVersions) {
                _context4.next = 15;
                break;
              }
              deletionCandidates = this.selectVersionsToDelete(response.LayerVersions, retainVersions);
              deleteQueue = deletionCandidates.map(function (layerVersion) {
                _this2.plugin.log("Removing layer version: ".concat(layerVersion.Version));
                return _this2.awsRequest('Lambda:deleteLayerVersion', {
                  LayerName: _this2.layerName,
                  VersionNumber: layerVersion.Version
                }, {
                  checkError: true
                });
              });
              _context4.next = 13;
              return Promise.all(deleteQueue);
            case 13:
              _context4.next = 15;
              return this.cleanUpLayers(retainVersions);
            case 15:
            case "end":
              return _context4.stop();
          }
        }, _callee4, this);
      }));
      function cleanUpLayers() {
        return _cleanUpLayers.apply(this, arguments);
      }
      return cleanUpLayers;
    }()
  }, {
    key: "selectVersionsToDelete",
    value: function selectVersionsToDelete(versions, retainVersions) {
      return versions.sort(function (a, b) {
        return parseInt(a.Version) === parseInt(b.Version) ? 0 : parseInt(a.Version) > parseInt(b.Version) ? -1 : 1;
      }).slice(retainVersions);
    }
  }]);
  return LayersService;
}(AbstractService);
module.exports = LayersService;
//# sourceMappingURL=LayersService.js.map